{-# LANGUAGE TemplateHaskell #-}

module HAL.Types where

import Control.Lens as L (makeLenses)
import Data.Aeson ((.:), (.:?), FromJSON(..), withObject)
import Protolude


-- Response type
data Response doc = Response
  { _numFound       :: Int
  , _start          :: Int
  , _docs           :: [doc]
  , _nextCursorMark :: Maybe Text
  } deriving (Show, Generic)
L.makeLenses ''Response

instance FromJSON doc => FromJSON (Response doc) where
  parseJSON = withObject "Response" $
    \o -> Response
            <$> ((o .: "response") >>= (.: "numFound"))
            <*> ((o .: "response") >>= (.: "start"))
            <*> ((o .: "response") >>= (.: "docs"))
            <*> (o .:? "nextCursorMark")
