module HAL.Utils where

import Data.LanguageCodes (ISO639_1(..), toChars)
import Data.Text qualified as T
import Protolude

allLangs :: [ISO639_1]
allLangs = enumFrom (toEnum 0) :: [ISO639_1]

toText :: ISO639_1 -> Text
toText lang = T.pack [l1, l2]
  where
    (l1, l2) = toChars lang

langAbstractS :: ISO639_1 -> Text
langAbstractS lang = toText lang <> "_abstract_s"
